require 'active_record/version'

module Delayed
  class Memento < ActiveRecord::Base

    self.table_name = :delayed_jobs_history

    if ActiveRecord::VERSION::MAJOR < 4 || defined?(ActiveRecord::MassAssignmentSecurity)
      attr_accessible :run_at, :priority, :handler, :queue, :locked_at,
                      :locked_by, :attempts, :failed_at, :last_error
    end

    cattr_accessor :expiration, :last_clean_up

    after_save :run_clean_up

    def run_clean_up
      current_time = Time.zone.now
      if @@expiration != nil && (@@last_clean_up.nil? || current_time - @@last_clean_up > @@expiration)
        Delayed::Memento.delete_all(['created_at < ?', current_time - @@expiration])
        @@last_clean_up = current_time
      end
    end

  end
end