require 'generators/delayed_job_memento/next_migration_version'
require 'rails/generators/migration'
require 'rails/generators/active_record'

module DelayedJobMemento
  module Generators
    class InstallGenerator < Rails::Generators::Base
      include Rails::Generators::Migration
      extend DelayedJobMemento::NextMigrationVersion

      desc "Adds delayed job history migration"
      self.source_paths << File.join(File.dirname(__FILE__), 'templates')

      def create_migration_file
        migration_template 'migration.rb', 'db/migrate/create_delayed_jobs_history.rb'
      end

      def self.next_migration_number dirname
        ActiveRecord::Generators::Base.next_migration_number dirname
      end
    end
  end
end