class CreateDelayedJobsHistory < ActiveRecord::Migration
  def self.up
    create_table :delayed_jobs_history, force: true do |t|
      t.datetime :created_at                                  # when job was completed
      t.text     :handler, null: false
      t.string   :queue
      t.datetime :locked_at
      t.string   :locked_by
      t.datetime :failed_at
      t.integer  :priority, default: 0, null: false
      t.datetime :run_at
      t.integer  :attempts, default: 0, null: false
      t.text     :last_error
      t.datetime :updated_at
    end

    add_index :delayed_jobs_history, :created_at, name: 'delayed_jobs_completed'
  end

  def self.down
    drop_table :delayed_jobs_history
  end
end